/*
 *	options.c
 */

#include "filer.h"

#define VO_SCREEN	0
#define VO_COLORS	1
#define VO_FONTPITCH	2
#define VO_HELP		3
#define VO_LAST		4

/*
 *	ViewOptions
 */
int ViewOptions()
{
	LISTBOX		lb;
	u8		*items[VO_LAST];
	int		res;

	memset(&lb, 0, sizeof lb);
	lb.title = "Filer Options";
	items[VO_SCREEN] = "Screen Direction";
	items[VO_COLORS] = "Color Selection";
	items[VO_FONTPITCH] = "Font pitch";
	items[VO_HELP] = "Help";
	lb.items = items;
	lb.nitems = arraysizeof(items);
	lb.defitem = 0;
	GetClientRect(&lb.rc);

	res = LB_ERROR;
	for (;;) {
		res = ListBox(&lb);
		if (res >= 0)
			lb.defitem = res;
		switch (res) {
		default:
			goto out;
		case VO_SCREEN:
			if (SelectScreen(lb.items[VO_SCREEN]) >= 0)
				goto out;
			break;
		case VO_COLORS:
			if (ColorSelection(lb.items[VO_COLORS]) >= 0) {
				res = LB_CANCEL; // Don't restart
				goto out;
			}
			break;
		case VO_FONTPITCH:
			if (SelectFontPitch(lb.items[VO_FONTPITCH]) >= 0)
				goto out;
			break;
		case VO_HELP:
			if (ViewHelp(lb.items[VO_HELP]) >= 0)
				goto out;
			break;
		}
		if (res >= 0)
			lb.defitem = res;
	}

out:
	return res;
}

#define TO_TOPPAGE	0
#define TO_SCREEN	1
#define TO_COLORS	2
#define TO_FONTPITCH	3
#define TO_FONT		4
#define TO_HELP		5
#define TO_LAST		6

/*
 *	TextOptions
 */
int TextOptions()
{
	LISTBOX		lb;
	u8		*items[TO_LAST];
	int		res;

	memset(&lb, 0, sizeof lb);
	lb.title = "Text Options";
	items[TO_TOPPAGE] = "Go to top page";
	items[TO_SCREEN] = "Screen Direction";
	items[TO_COLORS] = "Color Selection";
	items[TO_FONTPITCH] = "Font pitch";
	items[TO_FONT] = "Select Font";
	items[TO_HELP] = "Help";
	lb.items = items;
	lb.nitems = arraysizeof(items);
	lb.defitem = 0;
	GetClientRect(&lb.rc);

	res = LB_ERROR;
	for (;;) {
		res = ListBox(&lb);
		if (res >= 0)
			lb.defitem = res;
		switch (res) {
		default:
			goto out;
		case TO_TOPPAGE:
			res = ViewTextGoto(0);
			goto out;
		case TO_SCREEN:
			if (SelectScreen(lb.items[TO_SCREEN]) >= 0)
				goto out;
			break;
		case TO_COLORS:
			if (ColorSelection(lb.items[TO_COLORS]) >= 0) {
				res = LB_CANCEL; // Don't restart
				goto out;
			}
			break;
		case TO_FONTPITCH:
			if (SelectFontPitch(lb.items[TO_FONTPITCH]) >= 0)
				goto out;
			break;
		case TO_FONT:
			if (SelectFont(lb.items[TO_FONT]))
				goto out;
			break;
		case TO_HELP:
			if (ViewHelp(lb.items[TO_HELP]) >= 0)
				goto out;
			break;
		}
	}

out:
	return res;
}

