/*
 *	timer.c
 */

#include "filer.h"

vu32	ClockTick;

/*
 *	InitTimer
 */
void InitTimer()
{
	ClockTick = 0;

	/*
	 *	Initialize timer unit
	 */
	WRITE_REG16(TMR_CNT0, (u16)TIMER_COUNTER);
	WRITE_REG16(TMR_CTL0, TMR_ENABLE | TMR_INTREN | TMR_64CLOCK);

	/*
	 *	Enable interrupt
	 */
	WRITE_REG32(INT_VECTOR, (vu32)IRQHandler);
	WRITE_REG16(INT_IE, INT_TMR0);
	WRITE_REG16(INT_IME, INT_IME_ON);
}

/*
 *	Wait
 */
void Wait(u32 msec)
{
	msec += ClockTick;
	while (ClockTick < msec)
		;
}

